# ColorWheel (Javadocs: controlP5)
Date: 2014-04-27

controlP5

## Class ColorWheel

- java.lang.Object
- - controlP5.Controller<ColorWheel>
  - - controlP5.ColorWheel

All Implemented Interfaces:
  CDrawable, ControllerInterface<ColorWheel>, ControlP5Constants

    public class ColorWheel
    extends Controller<ColorWheel>

### Field Summary

### Fields inherited from class controlP5.Controller

`autoHeight, autoSpacing, autoWidth`

### Fields inherited from interface controlP5.ControlP5Constants

`acceptClassList, ACTION_BROADCAST, ACTION_CLICK, ACTION_DRAG, ACTION_ENTER, ACTION_EXIT, ACTION_LEAVE, ACTION_MOVE, ACTION_PRESS, ACTION_PRESSED, ACTION_RELEASE, ACTION_RELEASED, ACTION_RELEASEDOUTSIDE, ACTION_WHEEL, ACTIVE, ALL, ALT, AQUA, ARC, ARRAY, BACKSPACE, BASELINE, BITFONT, BLACK, BLUE, BOOLEAN, BOTTOM, BOTTOM_OUTSIDE, CAPTIONLABEL, CENTER, CHECKBOX, COMMANDKEY, CONTROL, controlEventClass, CUSTOM, DECREASE, DEFAULT, DELETE, DONE, DOWN, DROPDOWN, ELLIPSE, ENTER, ESCAPE, EVENT, eventMethod, FADEIN, FADEOUT, FIELD, FLOAT, FUCHSIA, GRAY, GREEN, grixel, HALF_PI, HIDE, HIGHLIGHT, HORIZONTAL, IDLE, IMAGE, INACTIVE, INCREASE, INTEGER, INVALID, J2D, KEYCONTROL, LEFT, LEFT_OUTSIDE, LIME, LINE, LIST, LOAD, MAROON, MENU, METHOD, MOVE, MULTI, MULTIPLES, NAVY, OLIVE, ORANGE, OVER, P2D, P3D, PI, PRESSED, PRINT, PURPLE, RED, RELEASE, RESET, RIGHT, RIGHT_OUTSIDE, SAVE, SHIFT, SILVER, SINGLE, SINGLE_COLUMN, SINGLE_ROW, SPRITE, standard56, standard58, STRING, SWITCH, SWITCH_BACK, SWITCH_FORE, synt24, TAB, TEAL, THEME_A, THEME_CP52014, THEME_CP5BLUE, THEME_RED, THEME_RETRO, THEME_WHITE, TOP, TOP_OUTSIDE, TRANSITION_WAIT_FADEIN, TREE, TWO_PI, UP, VALUELABEL, VERBOSE, VERTICAL, WAIT, WHITE, YELLOW`

### Constructor Summary

Constructors
Constructor and Description
`ColorWheel(ControlP5 theControlP5, ControllerGroup<?> theParent, java.lang.String theName, int theX, int theY, int theWidth, int theHeight)`
`ColorWheel(ControlP5 theControlP5, java.lang.String theName)`

### Method Summary

Methods
`int` `a()`
`int` `b()`
`int` `g()`
`int` `getRGB()`
`int` `HSLtoRGB(double[] theHSL)`
`int` `HSLtoRGB(double h, double s, double l)`
`int` `HSVtoRGB(double[] hsv)`
`int` `HSVtoRGB(double H, double S, double V)`
`void` `onDrag()`
`void` `onEndDrag()`
`void` `onPress()`
`void` `onRelease()`
`void` `onStartDrag()`
`int` `r()`
`double[]` `RGBtoHSL(int theRGB)`
`double[]` `RGBtoHSL(int theR, int theG, int theB)`
`double[]` `RGBtoHSV(int c)`
`double[]` `RGBtoHSV(int theR, int theG, double theB)`
`ColorWheel` `scrolled(int theRotationValue)`
`ColorWheel` `setAlpha(int theAlpha)`
`ColorWheel` `setHSL(double theH, double theS, double theL)`
`void` `setHue(double theH)`
`void` `setLightness(double theL)`
`ColorWheel` `setRGB(int theColor)`
`void` `setSaturation(double theS)`
`ColorWheel` `updateDisplayMode(int theMode)`
`ColorWheel` `updateViewMode(int theMode)`

### Methods inherited from class controlP5.Controller

`add, addCallback, addListener, align, bringToFront, bringToFront, changeValue, continuousUpdateEvents, draw, getAbsolutePosition, getAddress, getArrayValue, getArrayValue, getBehavior, getCaptionLabel, getColor, getControllerPlugList, getControlWindow, getDecimalPrecision, getDefaultValue, getHeight, getId, getInfo, getLabel, getMax, getMin, getName, getParent, getPickingColor, getPointer, getPosition, getProperty, getProperty, getStringValue, getTab, getValue, getValueLabel, getView, getWidth, getWindow, hide, init, isActive, isBroadcast, isInside, isLabelVisible, isListening, isLock, isMouseOver, isMousePressed, isMoveable, isUpdate, isUserInteraction, isVisible, keyEvent, linebreak, listen, listenerSize, lock, moveTo, moveTo, moveTo, moveTo, moveTo, moveTo, moveTo, moveTo, moveTo, plugTo, plugTo, plugTo, plugTo, registerProperty, registerProperty, registerTooltip, remove, remove, removeBehavior, removeCallback, removeCallback, removeListener, removeProperty, removeProperty, setAbsolutePosition, setAddress, setArrayValue, setArrayValue, setBehavior, setBroadcast, setCaptionLabel, setColor, setColorActive, setColorBackground, setColorCaptionLabel, setColorForeground, setColorValueLabel, setDecimalPrecision, setDefaultValue, setGroup, setGroup, setHeight, setId, setImage, setImage, setImages, setImages, setImages, setLabelVisible, setLock, setMax, setMin, setMouseOver, setMousePressed, setMoveable, setParent, setPosition, setPosition, setSize, setSize, setStringValue, setTab, setTab, setUpdate, setUserInteraction, setValue, setValueLabel, setValueSelf, setView, setView, setVisible, setWidth, show, toString, unlock, unplugFrom, unplugFrom, unregisterTooltip, update, updateAbsolutePosition, updateEvents, updateInternalEvents, updateSize`

### Methods inherited from class java.lang.Object

`equals, getClass, hashCode, notify, notifyAll, wait, wait, wait`

### Methods inherited from interface controlP5.ControllerInterface

`parent, setColorLabel, setColorValue, setLabel`

### Constructor Detail

#### ColorWheel

    public ColorWheel(ControlP5 theControlP5,
              ControllerGroup<?> theParent,
              java.lang.String theName,
              int theX,
              int theY,
              int theWidth,
              int theHeight)

#### ColorWheel

    public ColorWheel(ControlP5 theControlP5,
              java.lang.String theName)

### Method Detail

#### a

    public int a()

#### b

    public int b()

#### g

    public int g()

#### getRGB

    public int getRGB()

#### HSLtoRGB

    public int HSLtoRGB(double[] theHSL)

#### HSLtoRGB

    public int HSLtoRGB(double h,
               double s,
               double l)

Parameters:
  `h` - value between 0 and 360
  `s` - value between 0 and 100
  `l)` - value between 0 and 100
  `alpha` - value between 0 and 1
Returns:

#### HSVtoRGB

    public int HSVtoRGB(double[] hsv)

#### HSVtoRGB

    public int HSVtoRGB(double H,
               double S,
               double V)

Parameters:
  `H` - value between 0-1
  `S` - value between 0-1
  `V` - value between 0-1
Returns:
  int

#### onDrag

    public void onDrag()

#### onEndDrag

    public void onEndDrag()

#### onPress

    public void onPress()

#### onRelease

    public void onRelease()

#### onStartDrag

    public void onStartDrag()

#### r

    public int r()

#### RGBtoHSL

    public double[] RGBtoHSL(int theRGB)

#### RGBtoHSL

    public double[] RGBtoHSL(int theR,
                    int theG,
                    int theB)

Parameters:
  `theR` - value between 0 and 255
  `theG` - value between 0 and 255
  `theB` - value between 0 and 255
Returns:
  double[] values h,s,l are between 0-1

#### RGBtoHSV

    public final double[] RGBtoHSV(int c)

#### RGBtoHSV

    public final double[] RGBtoHSV(int theR,
                    int theG,
                    double theB)

Parameters:
  `theR` - value between 0 and 255
  `theG` - value between 0 and 255
  `theB` - value between 0 and 255
Returns:
  hsv [ hue (0-1) sat (0-1) val (0-1) ]

#### scrolled

    public ColorWheel scrolled(int theRotationValue)

#### setAlpha

    public ColorWheel setAlpha(int theAlpha)

#### setHSL

    public ColorWheel setHSL(double theH,
                    double theS,
                    double theL)

#### setHue

    public void setHue(double theH)

#### setLightness

    public void setLightness(double theL)

#### setRGB

    public ColorWheel setRGB(int theColor)

#### setSaturation

    public void setSaturation(double theS)

#### updateDisplayMode

    public ColorWheel updateDisplayMode(int theMode)

#### updateViewMode

    public ColorWheel updateViewMode(int theMode)